<?php

namespace Drupal\entity_template_ui\Access;

use Drupal\Core\Routing\Access\AccessInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\entity_template\BlueprintStorageInterface;
use Symfony\Component\Routing\Route;

class BlueprintStorageAccessCheck implements AccessInterface {

  /**
   * @param \Drupal\entity_template\BlueprintStorageInterface $blueprint_storage
   * @param \Drupal\Core\Session\AccountInterface $account
   * @param \Symfony\Component\Routing\Route $route
   *
   * @return \Drupal\Core\Access\AccessResultInterface
   */
  public function access(
    BlueprintStorageInterface $blueprint_storage,
    AccountInterface $account,
    Route $route
  ) {
    $operation = $route->getRequirement('_blueprint_storage_access');

    /** @var \Drupal\Core\Access\AccessResultInterface $access */
    $access = $blueprint_storage->access($operation, $account, TRUE);

    return $access;
  }

}
