<?php

namespace Drupal\entity_template_ui\PluginForm;

class InlineTemplateAddForm extends TemplateAddForm {

  /**
   * @var \Drupal\entity_template\Plugin\EntityTemplate\Component\InlineTemplate
   */
  protected $plugin;

  /**
   * {@inheritdoc}
   */
  protected function getRequiredReturnType() {
    $entity_type_id = $this->plugin->getFieldDefinition()->getSetting('target_type');

    if ($this->entityTypeManager->getDefinition($entity_type_id)->hasKey('bundle')) {
      $bundles = $this->entityTypeBundleInfo->getBundleInfo($entity_type_id);
      $selection_settings = $this->plugin->getFieldDefinition()->getSetting('handler_settings');

      if (count($bundles) === 1) {
        return "entity:{$entity_type_id}:".key($bundles);
      }
      else if (count($selection_settings['target_bundles']) === 1) {
        return "entity:{$entity_type_id}:".reset($selection_settings['target_bundles']);
      }
    }

    return "entity:{$entity_type_id}";
  }
}
