<?php

namespace Drupal\entity_template;

use Drupal\entity_template\Entity\BlueprintEntityInterface;

class BlueprintEntityAdaptor extends Blueprint {

  /**
   * @var \Drupal\entity_template\Entity\BlueprintEntityInterface
   */
  protected $entity;

  /**
   * BlueprintTemplateBlueprintEntityAdaptor constructor.
   *
   * @param \Drupal\entity_template\Entity\BlueprintEntityInterface $entity
   */
  public function __construct(BlueprintEntityInterface $entity) {
    $this->entity = $entity;
  }

  /**
   * Get the entity.
   *
   * @return \Drupal\entity_template\Entity\BlueprintEntityInterface
   */
  public function getEntity() {
    return $this->entity;
  }

  /**
   * {@inheritdoc}
   */
  public function getBuilder() {
    return $this->builderManager()
      ->createInstance($this->entity->getBuilder());
  }

  /**
   * {@inheritdoc}
   */
  public function getTemplatesConfiguration() {
    if (!$this->templatesCollection) {
      return $this->entity->getTemplates();
    }

    return $this->templatesCollection->getConfiguration();
  }

  /**
   * Get the template builder manager.
   *
   * @return \Drupal\entity_template\TemplateBuilderManager
   */
  protected function builderManager() {
    return \Drupal::service('plugin.manager.entity_template.builder');
  }
}
