<?php

namespace Drupal\entity_template\Plugin\EntityTemplate\Component;

interface SwappableComponentInterface extends ComponentInterface {

  /**
   * Compute whether the component is swappable.
   *
   * @return bool
   */
  public function isSwappable(): bool;

  /**
   * Get a list of plugin ids that can be swapped between.
   *
   * @return array
   */
  public function canSwapTo(): array;

  /**
   * Swap configuration to another component.
   *
   * @param \Drupal\entity_template\Plugin\EntityTemplate\Component\ComponentInterface $component
   *
   * @return \Drupal\entity_template\Plugin\EntityTemplate\Component\ComponentInterface
   */
  public function swapConfigurationTo(ComponentInterface $component): ComponentInterface;

}
