<?php

namespace Drupal\entity_template\Plugin\EntityTemplate\Template;


interface ConditionalTemplateInterface extends TemplateInterface {

  /**
   * Get the components of the template.
   *
   * @return \Drupal\Component\Plugin\LazyPluginCollection
   */
  public function getConditions();

  /**
   * Add a component
   *
   * @param array $configuration
   *
   * @return string
   */
  public function addCondition(array $configuration);

  /**
   * Remove a given component.
   *
   * @param $id
   */
  public function removeCondition($id);

  /**
   * Get a component by id.
   *
   * @param $id
   *
   * @return \Drupal\entity_template\Plugin\EntityTemplate\Component\ComponentInterface
   */
  public function getCondition($id);

}
